import { ExtractPropTypes, Ref } from 'vue';

interface IData {
    children: IData[];
    url: string;
}
declare const fallMenuProps: {
    data: {
        type: {
            (arrayLength: number): IData[];
            (...items: IData[]): IData[];
            new (arrayLength: number): IData[];
            new (...items: IData[]): IData[];
            isArray(arg: any): arg is any[];
            readonly prototype: any[];
            from<T>(arrayLike: ArrayLike<T>): T[];
            from<T, U>(arrayLike: ArrayLike<T>, mapfn: (v: T, k: number) => U, thisArg?: any): U[];
            from<T>(iterable: Iterable<T> | ArrayLike<T>): T[];
            from<T, U>(iterable: Iterable<T> | ArrayLike<T>, mapfn: (v: T, k: number) => U, thisArg?: any): U[];
            of<T>(...items: T[]): T[];
            fromAsync<T>(iterableOrArrayLike: AsyncIterable<T> | Iterable<T | PromiseLike<T>> | ArrayLike<T | PromiseLike<T>>): Promise<T[]>;
            fromAsync<T, U>(iterableOrArrayLike: AsyncIterable<T> | Iterable<T> | ArrayLike<T>, mapFn: (value: Awaited<T>) => U, thisArg?: any): Promise<Awaited<U>[]>;
            readonly [Symbol.species]: ArrayConstructor;
        };
        default: () => never[];
    };
    tiny_mode: StringConstructor;
    tiny_mode_root: BooleanConstructor;
    tiny_template: (FunctionConstructor | ObjectConstructor)[];
    tiny_renderless: FunctionConstructor;
    tiny_theme: StringConstructor;
    tiny_chart_theme: ObjectConstructor;
};

declare const arrowClick: (state: IFallMenuState) => (opt: any) => void;
declare const overContent: (state: IFallMenuState) => (on: any) => void;
declare const mouseover: ({ fall, props, state }: {
    fall: any;
    props: IFallMenuProps;
    state: IFallMenuState;
}) => (index: any) => void;
declare const mouseout: (state: IFallMenuState) => () => void;
declare const computePx: ({ props, refs, state }: {
    props: IFallMenuProps;
    refs: any;
    state: IFallMenuState;
}) => () => void;
declare const reRender: ({ api, state, timeout }: {
    api: IFallMenuApi;
    state: IFallMenuState;
    timeout?: NodeJS.Timeout;
}) => () => void;
declare const mounted: ({ api }: {
    api: any;
}) => () => void;
declare const beforeDestroy: (api: any) => () => void;
declare const computeLeft: ({ state }: {
    state: any;
}) => () => any;
declare const computeData: ({ props }: {
    props: IFallMenuProps;
}) => () => IData[];

interface IPagerData {
    data: IFallMenuProps['data'];
    offset: string[];
    index: number[];
    size?: number;
}
interface IFallMenuState {
    pager: number;
    level2data: IFallMenuProps['data'];
    activeNode: null;
    isActive: boolean;
    pagerData: IPagerData;
    left: any;
    data: IFallMenuProps['data'];
}
type IFallMenuProps = ExtractPropTypes<typeof fallMenuProps> & {
    value: boolean;
};
interface IFallMenuApi {
    fall: Ref<null>;
    state: IFallMenuState;
    computePx: ReturnType<typeof computePx>;
    mounted: ReturnType<typeof mounted>;
    computeLeft: ReturnType<typeof computeLeft>;
    beforeDestroy: ReturnType<typeof beforeDestroy>;
    computeData: ReturnType<typeof computeData>;
    arrowClick: ReturnType<typeof arrowClick>;
    overContent: ReturnType<typeof overContent>;
    mouseout: ReturnType<typeof mouseout>;
    mouseover: ReturnType<typeof mouseover>;
    reRender: ReturnType<typeof reRender>;
}

export { IFallMenuApi, IFallMenuProps, IFallMenuState, IPagerData };
